package paystation.domain;

public class PayStationImpl implements PayStation, ModifiablePayStation {
  private int insertedSoFar;
  private int timeBought;
  private RateStrategy rateStrategy;

  public PayStationImpl(RateStrategy rateStrategy) {
    this.rateStrategy = rateStrategy;
  }

  @Override
  public void addPayment(int coinValue) throws IllegalCoinException {
    insertedSoFar += coinValue;
    timeBought = rateStrategy.calculateTime(this);
  }

  @Override
  public int readDisplay() {
    return timeBought;
  }

  @Override
  public Receipt buy() {
    return new StandardReceipt(timeBought);
  }

  @Override
  public void cancel() {

  }

  @Override
  public int getInsertedSoFar() {
    return insertedSoFar;
  }

  @Override
  public void adjustInsertedSoFar(int newValue) {
    insertedSoFar = newValue;
  }
}
